/*
 * prism2dump v0.01 [decode_80211.c]
 * by h1kari - (c) Dachb0den Labs 2001
 */

/*
 * Copyright (c) 2001 Dachb0den Labs.
 *      David Hulton <h1kari@dachb0den.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by David Hulton.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY David Hulton AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL David Hulton OR THE VOICES IN HIS HEAD
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>
#include <sys/types.h>

#include <pcap.h>

#ifdef __FreeBSD__
#include <dev/wi/if_wavelan_ieee.h>
#else
#ifdef __OpenBSD__
#include <dev/ic/if_wi_ieee.h>
#endif
#endif

#include "prism2dump.h"


void
decode_80211(struct wi_rx_frame *wi_h)
{
  wi_h->wi_status    = le16toh(wi_h->wi_status);
  wi_h->wi_ts0       = le16toh(wi_h->wi_ts0);
  wi_h->wi_ts1       = le16toh(wi_h->wi_ts1);
  wi_h->wi_frame_ctl = le16toh(wi_h->wi_frame_ctl);
  wi_h->wi_id        = le16toh(wi_h->wi_id);
  wi_h->wi_seq_ctl   = le16toh(wi_h->wi_seq_ctl);
  wi_h->wi_dat_len   = le16toh(wi_h->wi_dat_len);

  printsol(0);

  print_80211_addrs(wi_h->wi_addr1, wi_h->wi_addr2, wi_h->wi_addr3);

  printeol(0);
  printsol(0);

  print_80211_status(wi_h->wi_status);
  print_80211_ts(wi_h->wi_ts0, wi_h->wi_ts1);
  printf("%u:%u %u:%u ", wi_h->wi_silence, wi_h->wi_signal, wi_h->wi_rate,
   wi_h->wi_rx_flow);

  printeol(0);
  printsol(0);

  print_80211_frame_ctl(wi_h->wi_frame_ctl);

  if((wi_h->wi_frame_ctl & WI_FCTL_FTYPE) == WI_FTYPE_CTL &&
   (wi_h->wi_frame_ctl & WI_FCTL_STYPE) == WI_STYPE_CTL_PSPOLL &&
   (wi_h->wi_id & WI_AID_SET) == WI_AID_SET)
    print_80211_id(wi_h->wi_id);

  print_80211_seq_ctl(wi_h->wi_seq_ctl);
  print_80211_addr4(wi_h->wi_addr4);
  print_80211_dat_len(wi_h->wi_dat_len);

  printeol(0);

  return;
}
